/*
 * cc -I/usr/include/drm -ldrm trim.c -o trim
 */

#include <stdio.h>
#include <errno.h>
#include <stdlib.h>
#include <xf86drm.h>
#include <radeon_drm.h>

#define B(a) (*(argv + (a)) ? *(argv + (a)) : 0)

main(argc, argv)
    char **argv;
{
    int fd;
    drm_radeon_syncf_t syncf;

    if ((fd = drmOpen("radeon", 0)) < 0) {
	printf("drmOpen: %s\n", strerror(errno)); exit(-1);
    }
    if (B(1) && B(2) && B(3)) {
	syncf.trim = VSF_SET_TRIM | atoi(B(3)) << 16 | atoi(B(2)) << 8 | (atoi(B(1)) & 0xff) << 0;
	printf("===> 0x%08x\n", syncf.trim);

	if (ioctl(fd, DRM_IOCTL_RADEON_SYNCF, &syncf)) {
	    printf("DRM_IOCTL_RADEON_SYNCF: %s\n", strerror(errno)); exit(-1);
	}
    } else {
	printf("SYNTAX: %s delta duration scanline\n", *argv);
	printf("sample: %s 24 1 82\n", *argv);
    }
}

